package edu.kit.ipd.descartes.adaptation.model.adaptation.dmm;

import java.io.PrintStream;
import java.io.PrintWriter;
import java.util.LinkedList;
import java.util.List;

import edu.kit.ipd.descartes.mm.adaptation.WeightedTactic;

public class TacticsHistory {
	
	public static final String NO_RESULT = "NoResult";

	private List<WeightedTactic> wTactic;
	private List<String> result;
	private List<Boolean> tacticWasSuccessful;

	private static TacticsHistory instance = null;

	private TacticsHistory() {
		wTactic = new LinkedList<WeightedTactic>();
		result = new LinkedList<String>();
		tacticWasSuccessful = new LinkedList<Boolean>();
	}

	public static TacticsHistory getInstance() {
		if (instance == null)
			instance = new TacticsHistory();

		return instance;
	}

	public void add(WeightedTactic weightedTactic, String resultId,
			boolean tacticWasSuccesful) {
		wTactic.add(weightedTactic);
		result.add(resultId);
		this.tacticWasSuccessful.add(tacticWasSuccesful);
	}

	public WeightedTactic getLatestAppliedTactic() {
	    if (wTactic.size() <= 0)
	        return null;
	    else
	        return wTactic.get(wTactic.size() - 1);
	}

	public String getLatestResultId() {
		return result.get(result.size() - 1);
	}

	public boolean wasLatestTacticSuccessful() {
		return tacticWasSuccessful.get(tacticWasSuccessful.size() - 1);
	}

	public int size() {
		if (wTactic.size() == result.size() && result.size() == tacticWasSuccessful.size()) 
			return wTactic.size();
		return -1;
	}

	public void printToSysOut() {
		print(System.out);
	}
	
	private void print(PrintStream stream) {
		PrintWriter out = new PrintWriter(stream);
		
		out.println(" A P P L I E D    T A C T I C S ");
		
		for (int i = 0; i < wTactic.size(); i++) {
			out.print(String
					.format("Applied tactic %1$3d: %2$30s. Result ID: %3$20s. Successful: %4$5s.%n",
							i + 1, wTactic.get(i).getUsedTactic().getName(),
							result.get(i), tacticWasSuccessful.get(i)));
		}
		out.flush();
	}
}
